---
title: Identifying resources on the Web
slug: Web/HTTP/Basics_of_HTTP/Identifying_resources_on_the_Web
tags:
  - Domain
  - HTTP
  - Path
  - Scheme
  - Syntax
  - URI
  - URL
  - URL Syntax
  - Web
  - fragment
  - port
  - query
  - resources
---
<div>{{HTTPSidebar}}</div>

<p class="summary">The target of an HTTP request is called a "resource", whose nature isn't defined further; it can be a document, a photo, or anything else. Each resource is identified by a Uniform Resource Identifier ({{Glossary("URI")}}) used throughout HTTP for identifying resources.</p>

<p>The identity and the location of resources on the Web are mostly given by a single URL (Uniform Resource Locator, a kind of URI). There are sometimes reasons identity and location are not given by the same URI: HTTP uses a specific HTTP header, {{HTTPHeader("Alt-Svc")}} when the resource requested wants the client to access it at another location.</p>

<h2 id="URLs_and_URNs">URLs and URNs</h2>

<h3 id="URLs">URLs</h3>

<p>The most common form of URI is the Uniform Resource Locator ({{Glossary("URL")}}), which is known as the <em>web address</em>.</p>

<pre class="notranslate">https://developer.mozilla.org
https://developer.mozilla.org/en-US/docs/Learn/
https://developer.mozilla.org/en-US/search?q=URL</pre>

<p>Any of those URLs can be typed into your browser's address bar to tell it to load the associated page (resource).</p>

<p>A URL is composed of different parts, some mandatory and others are optional. A more complex example might look like this:</p>

<pre class="notranslate">http://www.example.com:80/path/to/myfile.html?key1=value1&amp;key2=value2#SomewhereInTheDocument</pre>

<h3 id="URNs">URNs</h3>

<p>A Uniform Resource Name (URN) is a URI that identifies a resource by name in a particular namespace.</p>

<pre class="notranslate">urn:isbn:9780141036144
urn:ietf:rfc:7230
</pre>

<p>The two URNs correspond to</p>

<ul>
	<li>the book Nineteen Eighty-Four by George Orwell,</li>
	<li>the IETF specification 7230, Hypertext Transfer Protocol (HTTP/1.1): Message Syntax and Routing.</li>
</ul>

<h2 id="Syntax_of_Uniform_Resource_Identifiers_URIs">Syntax of Uniform Resource Identifiers (URIs)</h2>

<h3 id="Scheme_or_protocol">Scheme or protocol</h3>

<dl>
	<dt><img alt="Protocol" src="https://mdn.mozillademos.org/files/8013/mdn-url-protocol@x2.png" style="height: 70px; width: 440px;"></dt>
	<dd><code>http://</code> is the protocol. It indicates which protocol the browser must use. Usually it is the HTTP protocol or its secured version, HTTPS. The Web requires one of these two, but browsers also know how to handle other protocols such as <code>mailto:</code> (to open a mail client) or <code>ftp:</code> to handle file transfer, so don't be surprised if you see such protocols. Common schemes are:</dd>
</dl>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Scheme</th>
			<th scope="col">Description</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>data</td>
			<td><a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/Data_URIs">Data URIs</a></td>
		</tr>
		<tr>
			<td>file</td>
			<td>Host-specific file names</td>
		</tr>
		<tr>
			<td>ftp</td>
			<td><a href="/en-US/docs/Glossary/FTP">File Transfer Protocol</a></td>
		</tr>
		<tr>
			<td>http/https</td>
			<td><a href="/en-US/docs/Glossary/HTTP">Hyper text transfer protocol (Secure)</a></td>
		</tr>
		<tr>
			<td>javascript</td>
			<td>URL-embedded JavaScript code</td>
		</tr>
		<tr>
			<td>mailto</td>
			<td>Electronic mail address</td>
		</tr>
		<tr>
			<td>ssh</td>
			<td>Secure shell</td>
		</tr>
		<tr>
			<td>tel</td>
			<td>telephone</td>
		</tr>
		<tr>
			<td>urn</td>
			<td>Uniform Resource Names</td>
		</tr>
		<tr>
			<td>view-source</td>
			<td>Source code of the resource</td>
		</tr>
		<tr>
			<td>ws/wss</td>
			<td><a href="/en-US/docs/Web/API/WebSockets_API">WebSocket connections (Secure)</a></td>
		</tr>
	</tbody>
</table>

<h3 id="Authority">Authority</h3>

<dl>
	<dt><img alt="Domaine Name" src="https://mdn.mozillademos.org/files/8015/mdn-url-domain@x2.png" style="height: 70px; width: 440px;"></dt>
	<dd><code>www.example.com</code> is the domain name or authority that governs the namespace. It indicates which Web server is being requested. Alternatively, it is possible to directly use an {{Glossary("IP address")}}, but because it is less convenient, it is not often used on the Web.</dd>
</dl>

<h3 id="Port">Port</h3>

<dl>
	<dt><img alt="Port" src="https://mdn.mozillademos.org/files/8017/mdn-url-port@x2.png" style="height: 70px; width: 440px;"></dt>
	<dd><code>:80</code> is the port in this instance. It indicates the technical "gate" used to access the resources on the web server. It is usually omitted if the web server uses the standard ports of the HTTP protocol (80 for HTTP and 443 for HTTPS) to grant access to its resources. Otherwise it is mandatory.</dd>
</dl>

<h3 id="Path">Path</h3>

<dl>
	<dt><img alt="Path to the file" src="https://mdn.mozillademos.org/files/8019/mdn-url-path@x2.png" style="height: 70px; width: 440px;"></dt>
	<dd><code>/path/to/myfile.html</code> is the path to the resource on the Web server. In the early days of the Web, a path like this represented a physical file location on the Web server. Nowadays, it is mostly an abstraction handled by Web servers without any physical reality.</dd>
</dl>

<h3 id="Query">Query</h3>

<dl>
	<dt><img alt="Parameters" src="https://mdn.mozillademos.org/files/8021/mdn-url-parameters@x2.png" style="height: 70px; width: 440px;"></dt>
	<dd><code>?key1=value1&amp;key2=value2</code> are extra parameters provided to the Web server. Those parameters are a list of key/value pairs separated with the <code>&amp;</code> symbol. The Web server can use those parameters to do extra stuff before returning the resource to the user. Each Web server has its own rules regarding parameters, and the only reliable way to know how a specific Web server is handling parameters is by asking the Web server owner.</dd>
</dl>

<h3 id="Fragment">Fragment</h3>

<dl>
	<dt><img alt="Anchor" src="https://mdn.mozillademos.org/files/8023/mdn-url-anchor@x2.png" style="height: 70px; width: 440px;"></dt>
	<dd><code>#SomewhereInTheDocument</code> is an anchor to another part of the resource itself. An anchor represents a sort of "bookmark" inside the resource, giving the browser the directions to show the content located at that "bookmarked" spot. On an HTML document, for example, the browser will scroll to the point where the anchor is defined; on a video or audio document, the browser will try to go to the time the anchor represents. It is worth noting that the part after the #, also known as fragment identifier, is never sent to the server with the request.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>When using URLs in {{Glossary("HTML")}} content, you should generally only use a few of these URL schemes. When referring to subresources — that is, files that are being loaded as part of a larger document — you should only use the HTTP and HTTPS schemes. Increasingly, browsers are removing support for using FTP to load subresources, for security reasons.</p>

<p>FTP is still acceptable at the top level (such as typed directly into the browser's URL bar, or the target of a link), although some browsers may delegate loading FTP content to another application.</p>

<h2 id="Examples">Examples</h2>

<pre class="notranslate">https://developer.mozilla.org/en-US/docs/Learn
tel:+1-816-555-1212
git@github.com:mdn/browser-compat-data.git
ftp://example.org/resource.txt
urn:isbn:9780141036144
mailto:help@supercyberhelpdesk.info
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Title</th>
		</tr>
		<tr>
			<td>{{RFC("7230", "Uniform Resource Identifiers", "2.7")}}</td>
			<td>Hypertext Transfer Protocol (HTTP/1.1): Message Syntax and Routing</td>
		</tr>
	</tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Learn/Common_questions/What_is_a_URL">What is a URL?</a></li>
	<li><a href="http://www.iana.org/assignments/uri-schemes/uri-schemes.xhtml">IANA list of URI schemes</a></li>
</ul>
